#include <cstdio>
#include <cmath>
#include <cstring>
#define inf 0x3f3f3f3f
#define cost first
#define vecin second
#define nmax 1202
#define eps 10e-6

using namespace std;

struct punct
{
    double x,y;
};

double a[nmax][nmax],d[nmax];
bool viz[nmax];
punct v[nmax];
int n;

void citire()
{
    scanf("%d",&n);
    for(int i=1;i<=n;i++)
        scanf("%lf%lf",&v[i].x,&v[i].y);
}

double distanta(punct a,punct b)
{
    return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}

void initializare()
{
    for(int i=1;i<n;i++)
        for(int j=i+1;j<=n;j++)
        {
            a[i][j]=distanta(v[i],v[j]);
            a[j][i]=a[i][j];
        }
    for(int i=1;i<=n;i++)
        d[i]=inf;
}

int minim()
{
    double mn=inf;
    int pozmn;
    for(int i=1;i<=n;i++)
        if(mn-d[i]>eps&&viz[i]==0)
        {
            mn=d[i];
            pozmn=i;
        }
    return pozmn;
}

void prim()
{
    int k;
    d[1]=0;
    for(int j=1;j<=n;j++)
    {
        k=minim();
        viz[k]=1;
        for(int i=1;i<=n;i++)
            if(i!=k)
                if(viz[i]==0&&d[i]-a[k][i]>eps)
                    d[i]=a[k][i];
    }
}

void afisare()
{
    double s=0;
    for(int i=2;i<=n;i++)
        s+=d[i];
    printf("%lf\n",s);
}

int main()
{
    freopen("curent.in","r",stdin);
    freopen("curent.out","w",stdout);
    citire();
    initializare();
    prim();
    afisare();
    return 0;
}
