#include <cstdio>
#define nmax 1210
#include <cmath>
#include <queue>

using namespace std;

/*
clasa XI B
*/

struct pare{
    float x,y;
};
int n;
float s;
void read();
inline float dis(pare,pare);
pare stat[nmax];
priority_queue <pair<float,pair<int,int> > > heap;
void kruskal();
bool vis[nmax];

int main(){
    freopen("curent.in","r",stdin);
    freopen("curent.out","w",stdout);
    read();
    kruskal();
    printf("%f\n",s);
    return 0;
}
inline float dis(pare p1,pare p2){
    return sqrt((p1.x - p2.x)*(p1.x - p2.x) + (p1.y - p2.y)*(p1.y - p2.y));
}
void read(){
    scanf("%d ",&n);
    float x,y;
    for(int i = 1;i <= n;i++){
        scanf("%f %f ",&x,&y);
        stat[i].x = x;
        stat[i].y = y;
        for(int j = 1;j < i;j++){
            heap.push(make_pair(-dis(stat[i],stat[j]),make_pair(i,j)));
        }
    }
}
void kruskal(){
    s = 0;
    int h = n - 1;
    int x,y;
    float vl;
    while(h){
        x = heap.top().second.first;
        y = heap.top().second.second;
        vl = -heap.top().first;
        heap.pop();
        if(vis[x] == false || vis[y] == false){
            vis[x] = vis[y] = true;
            h--;
            s += vl;
        }
    }
}
