//Alexandru GHITA

#include <cstdio>
#include <vector>
#include <cmath>
#include <algorithm>

#define NMAX 1205

using namespace std;

struct punct
{
    double x, y;
} A[NMAX];

struct muchie
{
    double c;
    int x, y;
} B[(NMAX * (NMAX - 1)) / 2];

int N, nrm, tata[NMAX];

double distanta(punct a, punct b)
{
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

int caut_tata(int nod)
{
    if (tata[nod] != nod)
        return caut_tata(tata[nod]);
    return nod;
}

struct cmp
{
    bool operator()(muchie a, muchie b)
    {
        return (a.c < b.c);
    }
};

void citire()
{
    double dist;

    scanf("%d", &N);
    for (int i = 1; i <= N; ++i)
        scanf("%lf %lf", &A[i].x, &A[i].y);
    for (int i = 1; i < N; ++i)
        for (int j = i + 1; j <= N; ++j)
        {
            dist = distanta(A[i], A[j]);
            B[++nrm].x = i;
            B[nrm].y = j;
            B[nrm].c = dist;
        }
    for (int i = 1; i <= N; ++i)
        tata[i] = i;

    sort(B + 1, B + nrm + 1, cmp());
}

void rezolvare()
{
    int n1, n2, mins = 0;
    double ans = 0;

    for (int i = 1; i <= nrm, mins < N - 1; ++i)
    {
        n1 = B[i].x;
        n2 = B[i].y;
        if (caut_tata(n1) != caut_tata(n2))
        {
            mins++;
            tata[caut_tata(n2)] = caut_tata(n1);
            ans += B[i].c;
        }
    }
    printf("%.5lf", ans);
}

int main()
{
    freopen("curent.in", "r", stdin);
    freopen("curent.out", "w", stdout);

    citire();
    rezolvare();

    return 0;
}
