//Alexandru GHITA

#include <cstdio>
#include <cstring>

#define NMAX 155
#define VMAX 12000

int N, A[NMAX], V[VMAX][NMAX], vtot, vjum;
bool used[NMAX];

void citire()
{
    scanf("%d", &N);

    for (int i = 1; i <= N; ++i)
    {
        scanf("%d", &A[i]);
        vtot += A[i];
    }

    vjum = vtot / 2;
    memset(V, -1, sizeof(V));
}

void dinamica()
{
    for (int i = 1; i <= N; ++i)
    {
        for (int j = vjum; j >= A[i]; --j)
        {
            if (V[0][j] == -1 && V[0][j - A[i]] != -1)
            {
                for (int k = 1; k < i; ++k)
                    if (V[k][j - A[i]] != -1)
                    {
                        V[i][j] = k;
                        break;
                    }
                V[0][j] = i;
            }
        }
        if (V[0][A[i]] == -1)
        {
            V[0][A[i]] = 0;
            V[i][A[i]] = 0;
        }
    }

    /*for (int i = 0; i <= N; ++i)
    {
        for (int j = 1; j <= vjum; ++j)
            if (V[i][j] > -1)
                printf("%d ", V[i][j]);
            else printf("# ");
        printf("\n");
    }*/
}

void reconstituire()
{
    int aux, aux2, line;

    for (int i = vjum; i >= 0; --i)
    {
        if (V[0][i] != -1)
        {
            line = V[0][i];
            aux = i;
            break;
        }
    }

    printf("%d %d\n", aux, vtot - aux);

    do
    {
        printf("%d ", A[line]);
        used[line] = true;
        aux2 = aux;
        aux -= A[line];
        line = V[line][aux2];
    }while (V[line][aux] != 0);
    printf("%d\n", A[line]);
    used[line] = true;

    for (int i = 1; i <= N; ++i)
        if (used[i] == false)
            printf("%d ", A[i]);
}

int main()
{
    freopen("cadou.in", "r", stdin);
    freopen("cadou.out", "w", stdout);

    citire();
    if (N == 2)
    {
        printf("%d %d\n%d\n%d", A[1], A[2], A[1], A[2]);
        return 0;
    }
    dinamica();
    reconstituire();

    return 0;
}
