///Roatis Razvan
///clasa X-B
#include <iostream>
#include <cstdio>
#include <cstring>
#include <queue>

#define mmx 105
#define inf 0x3f3f3f3f

using namespace std;

struct elem
{
    int x ;
    int y ;
};

queue <elem> S;

int sol[mmx][mmx][2] , n , m ;
int a1,a2,m1,m2,maxim=inf;

void citire() ;
void bordare() ;
void lee() ;
void solve() ;

int main()
{
    freopen( "programatori.in" , "r" , stdin ) ;
    freopen( "programatori.out" , "w" , stdout ) ;
    citire() ;
    bordare() ;
    lee() ;
    solve() ;
    printf( "%d\n" , maxim ) ;
    return 0;
}

void citire()
{
    char s[mmx] ;
    scanf( "%d %d\n" , &n , &m ) ;
    for ( int i = 1 ; i <= n ; i ++ )
    {
        fgets( s , mmx , stdin ) ;
        int x = strlen(s) - 1 ;
        for ( int j = 0 ; j < x ; j ++ )
            if ( s[j] == 'X' )
            {
                sol[i][j+1][0] = -1 ;
                sol[i][j+1][1] = -1 ;
            }
            else if ( s[j] == 'A' )
            {
                a1 = i ;
                a2 = j + 1 ;
            }
            else if ( s[j] == 'M' )
            {
                m1 = i ;
                m2 = j + 1 ;
            }
    }
}

void bordare()
{
    for ( int i = 0 ; i <= n + 1 ; i ++ )
    {
        sol[i][0][0] = -1 ;
        sol[i][m+1][0] = -1 ;
        sol[i][0][1] = -1 ;
        sol[i][m+1][1] = -1 ;
    }
    for ( int i = 0 ; i <= m + 1 ; i ++ )
    {
        sol[0][i][0] = -1 ;
        sol[n+1][i][0] = -1 ;
        sol[0][i][1] = -1 ;
        sol[n+1][i][1] = -1 ;
    }
}

void lee()
{
    int p1[] = {-1,-1,0,1,1,1,0,-1} , p2[] = {0,1,1,1,0,-1,-1,-1} ;
    elem e;
    for ( int i = 0 ; i < 2 ; i ++ )
    {
        if ( i == 0 )
        {
            e.x = a1;
            e.y = a2;
            S.push(e) ;
            sol[a1][a2][0] = 1 ;
        }
        else
        {
            e.x = m1 ;
            e.y = m2 ;
            S.push(e) ;
            sol[m1][m2][1] = 1 ;
        }
        while ( not S.empty() )
        {
            int a = S.front().x , b = S.front().y ;
            S.pop() ;
            for ( int j = 0 ; j < 8 ; j ++ )
                if ( not sol[a+p1[j]][b+p2[j]][i] )
                {
                    sol[a+p1[j]][b+p2[j]][i] = sol[a][b][i] + 1 ;
                    e.x = a + p1[j] ;
                    e.y = b + p2[j] ;
                    S.push(e) ;
                }
        }
    }
}

void solve()
{
    for ( int i = 1 ; i <= n ;  i ++ )
        for ( int j = 1 ; j <= m ; j ++ )
            if ( sol[i][j][0] == sol[i][j][1] && sol[i][j][0] > 0 && sol[i][j][0] < maxim )
                maxim = sol[i][j][0] ;
}
