/// INELUS Gabriel Robert
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cstring>

#define Nmax 1350
#define x first
#define y second
#define INF 0x3f3f3f3f

using namespace std;
pair<double,double> p[Nmax];
int N;
double DP[Nmax];
int used[Nmax];
int tata[Nmax];

void Read()
{
    scanf("%d",&N);
    double aaa,bbb;
    for(int i = 1; i <= N; ++i){
        scanf("%lf%lf",&aaa,&bbb);
        p[i] = make_pair(aaa,bbb);
    }
}

double dist(pair<double,double> A,pair<double,double> B)
{
    double d = (A.x - B.x)*(A.x - B.x) + (A.y - B.y)*(A.y - B.y);
    d = sqrt((double)d);
    return d;
}

int get_min()
{
    double mini = INF;
    int pzmin = 0;
    for(int i = 1; i <= N; ++i)
        if(mini > DP[i] && !used[i]){
            mini = DP[i];
            pzmin = i;
        }
    used[pzmin] = 1;
    return pzmin;
}

void Prim()
{
    for(int i = 1; i <= N; ++i)
        DP[i] = INF;
    DP[1] = 0;
    int k;
    for(int i = 1; i <= N; ++i)
    {
        k = get_min();
        for(int j = 1; j <= N; ++j)
            if(!used[j])
                if(DP[j] > dist(p[k],p[j]))
                {
                    DP[j] = dist(p[k],p[j]);
                    tata[j] = k;
                }
    }
    double rez = 0;
    for(int i = 1; i <= N; ++i)
        rez += DP[i];
    printf("%.6lf",rez);
}

int main()
{
    freopen("curent.in","r",stdin);
    freopen("curent.out","w",stdout);

    Read();
    Prim();

    return 0;
}
